#include <libspe2.h>

#define TASK_MULTIPLIER 4

int main () {

        spe_program_handle_t *spe_program = spe_image_open("spu_run_example");

        unsigned long i;

        int tasks = TASK_MULTIPLIER * spe_cpu_info_get (SPE_COUNT_USABLE_SPES , 0);

        spe_context_ptr_t ctx[tasks];

        unsigned int createflags=0;
        unsigned int entry[tasks];
        unsigned int runflags=0;

        //initiate all contexts

        for ( i = 0 ; i < tasks ; i++ ) {
                ctx[i] = spe_context_create( createflags , NULL);
		entry[i]=SPE_DEFAULT_ENTRY;
                if (spe_program_load( ctx[i], spe_program ) < 0 ) {
                        perror(" error loading spu-elf" );
                }
        }
        
	//run all contexts once per loop

        for ( i = 0 ; i < tasks ; i++ ) {

                printf("ppu: attemting to run id %d \n",(int)i);

                spe_context_run(ctx[i], &entry[i], runflags, NULL, (void*)i, NULL);

        }

        for ( i = 0 ; i < tasks ; i++ ) {

                printf("ppu: attemting to run id %d again\n",(int)i);

                spe_context_run(ctx[i], &entry[i], runflags, NULL, (void*)i, NULL);

        }

        for ( i = 0 ; i < tasks ; i++ ) {

                printf("ppu: attemting to run id %d one last time\n",(int)i);

                spe_context_run(ctx[i], &entry[i], runflags, NULL, (void*)i, NULL);

		spe_context_destroy(ctx[i]);
        }
	

	return 0;
}

